rjpmReturn3<-function(n,resolution=0,gevOrPot=1,numbOfTidalBands=5,confidenceBool=0,rValue=30,empBool=0,pReturn=c(1/5,1/10,1/20,1/100,1/200)) {
	uForMeasuredVector<-c(287,278,134,390,255,70,250,105)
	place<- if (n==1) "oslo" else if (n==2) "heimsjo" else if (n==3) "honning" else if (n==4) "osloCorrected" else if (n==5) "narvik" else if (n==6) "harstad" else if (n==7) "tregde" else if (n==8) "andenesHours" else if (n==9) "vikerHours" 
	measuredValues<-get(paste(place,"MV",sep=""))
	totMaxims<-get(paste(place,"MeasuredMaxims",sep=""))
	x<-get(paste(place,"PredCommon",sep=""))
	surgeValues<-get(paste(place,"Surge",sep=""))
	N<-numbPerYear
	
	if (numbOfTidalBands>1) {
		times<-get(paste(place,"MeasuredTimes",sep=""))
		tmp<-conditionOnTide(n,numbOfTidalBands)
		a1Vec<-tmp$a1
		a2Vec<-tmp$a2
		correctedSurge<-(surgeValues-a1Vec)/(a2Vec-a1Vec)
		surgeMaxims<-extractMaxims(correctedSurge,times,0.75)
	} else {
		a1Vec<-rep(0,length(surgeValues))
		a2Vec<-rep(1,length(surgeValues))
		correctedSurge<-surgeValues
		surgeMaxims<-get(paste(place,"SurgeMaxims",sep=""))		
	}
	qValue<-sum(measuredValues<=uForMeasuredVector[n-1])/length(measuredValues)
	HAT<-max(x)
	potThreshold<-sort(measuredValues)[qValue*length(measuredValues)]
	surgePotThreshold<-sort(surgeValues)[qValue*length(surgeValues)]
	correctedPotThreshold<-sort(correctedSurge)[qValue*length(correctedSurge)]
	empiricalThreshold<-surgePotThreshold+HAT
	aVec<-a1Vec[(length(x)-T):length(x)]
	bVec<-a2Vec[(length(x)-T):length(x)]-aVec
	x<-x[(length(x)-T):length(x)]
	T<-18.61*365.25*24

	thetaEst<-exi(measuredValues,u=potThreshold,r=rValue)
	if (empBool) {
		condition<-empiricalThreshold>0.7*max(totMaxims)

		if (condition) {
			zEmpCheck<-seq(0.7*max(totMaxims),empiricalThreshold,5)
			leftEmp<-T*thetaEst^(-1)*log(1-pReturn)/N
			rightEmp<-c()
			for (zToCheck in zEmpCheck) {
				valueCheck<-(zToCheck-x-aVec)/bVec
				uniqueCheck<-unique(valueCheck)
				summer<-rep(0,length(valueCheck))
				for (value in uniqueCheck) {
					summer[valueCheck==value]<-sum(correctedSurge<=value)
				}
				summer<-summer/length(correctedSurge)
				rightEmp<-c(rightEmp,sum(log(summer)))
			}

			leftEmp<-leftEmp[leftEmp<max(rightEmp)]
			smallestDiffWhich<-0
			diffValues<-c()
			retLevelsEmp<-c()
			for (leftValue in leftEmp) {
				diffValues<-abs(rightEmp-leftValue)
				smallestDiffWhich<-which.min(diffValues)
				retLevelsEmp<-c(retLevelsEmp,zEmpCheck[smallestDiffWhich])
			}
			if (resolution) {
				retLevelsEmp2<-c()
				for (j in 1:length(retLevelsEmp)) {
					newCheckZ<-seq(retLevelsEmp[j]-2.5,retLevelsEmp[j]+2.5,0.2)
					rightEmp2<-c()
					for (zToCheck in newCheckZ) {
						valueCheck<-(zToCheck-x-aVec)/bVec
						uniqueCheck<-unique(valueCheck)
						summer<-rep(0,length(valueCheck))
						for (value in uniqueCheck) {
							summer[valueCheck==value]<-sum(correctedSurge<=value)
						}
						summer<-summer/length(correctedSurge)
						rightEmp2<-c(rightEmp2,sum(log(summer)))
					}
					diffValuesBetter<-abs(rightEmp2-leftEmp[j])
					smallestOfTheSmall<-which.min(diffValuesBetter)
					retLevelsEmp2<-c(retLevelsEmp2,newCheckZ[smallestOfTheSmall])
				}
			} else {
				retLevelsEmp2<-retLevelsEmp
			}
		zCheck <- seq(empiricalThreshold,1.3*max(totMaxims),5)
		} else {
			zCheck <- seq(0.7*max(totMaxims),1.3*max(totMaxims),5)
		}
	} else {
		zCheck <- seq(0.7*max(totMaxims),1.3*max(totMaxims),5)
		retLevelsEmp2<-c()
		condition<-FALSE
	}

	surgeGEV<-fgev(surgeMaxims)
	muSGEV<-surgeGEV$param[1]
	if (confidenceBool) {
		muErr<-surgeGEV$std.err[1]
		muCI<-c(muSGEV-1.96*muErr,muSGEV+1.96*muErr)
	}
	if (!gevOrPot) {
		sigmaSGEV<-surgeGEV$param[2]
		xiSGEV<-surgeGEV$param[3]
		if (confidenceBool) {
			sigmaErr<-surgeGEV$std.err[2]
			xiErr<-surgeGEV$std.err[3]
			sigmaCI<-c(sigmaSGEV-1.96*sigmaErr,sigmaSGEV+1.96*sigmaErr)
		}
	}

	if (gevOrPot) {
		surgePot<-fpot(correctedSurge,threshold=correctedPotThreshold,r=rValue,model="gpd",cmax=TRUE,ulow=-Inf)
		xiSGEV<-surgePot$estimate[2]
		sigmaSPot<-surgePot$estimate[1]
		sigmaSGEV<-sigmaSPot-xiSGEV*(correctedPotThreshold-muSGEV)
		if (confidenceBool) {
			sigmaPotErr<-surgePot$std.err[1]
			xiErr<-surgePot$std.err[2]
			sigmaPotCI<-c(sigmaSPot-1.96*sigmaPotErr,sigmaSPot+1.96*sigmaPotErr)
			xiCI<-c(xiSGEV-1.96*xiErr,xiSGEV+1.96*xiErr)
			sigmaCI<-c(sigmaPotCI[1]-xiCI[1]*(correctedPotThreshold-muCI[1]),sigmaPotCI[2]-xiCI[2]*(correctedPotThreshold-muCI[2]))
		}
	}
	thetaSEst<-if (!gevOrPot) exi(correctedSurge,u=correctedPotThreshold,r=rValue) else surgePot$extind

	findLevels<-function(muSGEV,sigmaSGEV,xiSGEV,aVec,bVec,thetaEst,thetaSEst,zCheck,resolution,condition,retLevelsEmp2) {
		alwaysTheSame<-1-xiSGEV*(muSGEV*bVec+aVec+x)/(sigmaSGEV*bVec)
		leftSide<- -T*thetaSEst*thetaEst^(-1)*log(1-pReturn)
		if (condition) {
			leftSide<-leftSide[(length(retLevelsEmp2)+1):length(leftSide)]
		}
		rightSide<-c()
		toBeSummed<-0
		for (zToCheck in zCheck) {
			toBeSummed<-xiSGEV*zToCheck/(sigmaSGEV*bVec)+alwaysTheSame
			toBeSummed<-toBeSummed[toBeSummed>0]
			rightSide<-c(rightSide,sum((toBeSummed)^(-1/xiSGEV)))
		}

		rightSide<-rightSide[rightSide!=0]
		zCheck<-zCheck[rightSide!=0]

		retLevels<-c()
		for (leftValue in leftSide) {
			diffValues<-abs(rightSide-leftValue)
			smallestDiffWhich<-which.min(diffValues)
			retLevels<-c(retLevels,zCheck[smallestDiffWhich])
		}

		#Better resolution
		if (resolution) {
			retLevelsBetter<-c()
			for (j in 1:length(retLevels)) {
				newCheckZ<-seq(retLevels[j]-2.5,retLevels[j]+2.5,0.1)
				rightSideBetter<-c()
				for (zToCheck in newCheckZ) {
					toBeSummed<-xiSGEV*zToCheck/(sigmaSGEV*bVec)+alwaysTheSame
					toBeSummed<-toBeSummed[toBeSummed>0]
					rightSideBetter<-c(rightSideBetter,sum((toBeSummed)^(-1/xiSGEV)))
				}
				diffValuesBetter<-abs(rightSideBetter-leftSide[j])
				smallestOfTheSmall<-which.min(diffValuesBetter)
				retLevelsBetter<-c(retLevelsBetter,newCheckZ[smallestOfTheSmall])
			}
		} else {
			return(retLevels)
		}
		if (condition) {
			return(c(retLevelsEmp2,retLevelsBetter))
		} else {
			return(retLevelsBetter)
		}
	}
	retLevelsBetter<-findLevels(muSGEV,sigmaSGEV,xiSGEV,aVec,bVec,thetaEst,thetaSEst,zCheck,resolution,condition,retLevelsEmp2)
	if (confidenceBool) {
		zCheckLow<-0.9*zCheck
		zCheckHigh<-1.1*zCheck
		lowerCI<-findLevels(muCI[1],sigmaCI[1],xiCI[1],aVec,bVec,thetaEst,thetaSEst,zCheckLow,resolution,condition,retLevelsEmp2)
		upperCI<-findLevels(muCI[2],sigmaCI[2],xiCI[2],aVec,bVec,thetaEst,thetaSEst,zCheckHigh,resolution,condition,retLevelsEmp2)
	} else {
		lowerCI<-0
		upperCI<-0
		muErr<-0
		sigmaPotErr<-0
		xiErr<-0
	}
	return(list(coefs=c(muSGEV,sigmaSGEV,xiSGEV),std.err=c(muErr,sigmaPotErr,xiErr),quantile=qValue,theta=thetaEst,thetas=thetaSEst,retlevels=retLevelsBetter,lowerci=lowerCI,upperci=upperCI))
}

#Tide-surge interaction

tideSurgeInt<-function(n,correctedOrNot=0,plotOrNot=1,numbOfTidalBands) {
	place<- if (n==1) "oslo" else if (n==2) "heimsjo" else if (n==3) "honning" else if (n==4) "osloCorrected" else if (n==5) "narvik" else if (n==6) "harstad" else if (n==7) "tregde" else if (n==8) "andenesHours" else if (n==9) "vikerHours" else "synth"
	locationName<- if (n==1) "Oslo" else if (n==2) "Heimsjø" else if (n==3) "Honningsvåg" else if (n==4) "Oslo" else if (n==5) "Narvik" else if (n==6) "Harstad" else if (n==7) "Tregde" else if (n==8) "Andenes" else if (n==9) "Viker" else "synthetic data"
	surgeValues<-get(paste(place,"Surge",sep=""))
	predCommon<-get(paste(place,"PredCommon",sep="")) 
	dataYears<-get(paste(place,"DataYears",sep=""))

	if (correctedOrNot==1) {
		tmp<-conditionOnTide(n,numbOfTidalBands)
		surgeValues<-(surgeValues-tmp$a1)/(tmp$a2-tmp$a1)
	}
	surgePotThreshold<-sort(surgeValues)[0.9975*length(surgeValues)]

	#numbOfTidalBands<-5
	uQuantileLevel<-sum(surgeValues>surgePotThreshold)/length(surgeValues)

	numberPerBand<-length(predCommon)/numbOfTidalBands
	tidalBandMatrix<-matrix(NA,numbOfTidalBands,ceiling(numberPerBand))
	predOrderWhich<-order(predCommon)
	predOrdered<-predCommon[predOrderWhich]
	surgeSameOrder<-surgeValues[predOrderWhich]
	surgeHere<-c()
	for (i in 1:numbOfTidalBands) {
		surgeHere<-surgeSameOrder[(1+numberPerBand*(i-1)):(numberPerBand*i)]
		tidalBandMatrix[i,1:length(surgeHere)]<-surgeHere
	}

	surgesPerTidalBand<-c()
	i<-1
	surgeToPlot<-tidalBandMatrix[i,]	
	surgePlotWhich<-surgeToPlot>surgePotThreshold
	surgeToPlot<-surgeToPlot[surgePlotWhich]
	tideToPlot<-predOrdered[(1+numberPerBand*(i-1)):(numberPerBand*i)]
	tideToPlot<-tideToPlot[surgePlotWhich]
	if (plotOrNot==1) {
		title1<-if (correctedOrNot==0) "Surge data" else "Corrected surge data"
		plot(surgeToPlot,tideToPlot,xlim=c(surgePotThreshold,max(surgeValues)),ylim=c(min(predCommon),max(predCommon)),xlab="Surge level (cm)",ylab="Tide level (cm)",main=title1)
		abline(h=max(tideToPlot,na.rm=TRUE))
	}
	surgesPerTidalBand<-c(surgesPerTidalBand,length(surgeToPlot))

	expObs<-length(surgeValues)*uQuantileLevel/numbOfTidalBands
	chiSquareTest<-(length(surgeToPlot)-expObs)^2
	for (i in 2:numbOfTidalBands) {
		surgeToPlot<-tidalBandMatrix[i,]	
		surgePlotWhich<-surgeToPlot>surgePotThreshold
		surgeToPlot<-surgeToPlot[surgePlotWhich]
		tideToPlot<-predOrdered[(1+numberPerBand*(i-1)):(numberPerBand*i)]
		tideToPlot<-tideToPlot[surgePlotWhich]
		if (plotOrNot==1) {
			points(surgeToPlot,tideToPlot)
			abline(h=max(tideToPlot,na.rm=TRUE))
		}
		surgesPerTidalBand<-c(surgesPerTidalBand,length(surgeToPlot))

		chiSquareTest<-chiSquareTest+(length(surgeToPlot)-expObs)^2
	}
	chiSquareTest<-chiSquareTest/expObs
	chiTable<-qchisq(0.95,numbOfTidalBands-1)
	totExtremeSurges<-sum(surgesPerTidalBand)
	return(list(u=surgePotThreshold,surgesperband=surgesPerTidalBand,totsurges=totExtremeSurges,percentperband=100*surgesPerTidalBand/totExtremeSurges,chisquare=chiSquareTest,chitable=chiTable,chidivdata=chiSquareTest/length(dataYears)))
}

conditionOnTide<-function(n,numbOfTidalBands) {
	place<- if (n==1) "oslo" else if (n==2) "heimsjo" else if (n==3) "honning" else if (n==4) "osloCorrected" else if (n==5) "narvik" else if (n==6) "harstad" else if (n==7) "tregde" else if (n==8) "andenesHours" else if (n==9) "vikerHours" else "synth"
	surgeValues<-get(paste(place,"Surge",sep="")) 
	predCommon<-get(paste(place,"PredCommon",sep="")) 

	aQuantLevels<-c(0.98,0.99)

	numberPerBand<-length(predCommon)/numbOfTidalBands
	remainder<-(numberPerBand-floor(numberPerBand))*numbOfTidalBands

	predOrderWhich<-order(predCommon)
	predOrdered<-predCommon[predOrderWhich]
	surgeSameOrder<-surgeValues[predOrderWhich]
	A1quants<-c()
	A2quants<-c()
	aQuantiles<-round(numberPerBand*aQuantLevels)
	midPoints<-predOrdered[1]
	for (i in 1:numbOfTidalBands) {
		remainderHere<-if (remainder>0) 1 else 0
		sortedWhich<-(1+numberPerBand*(i-1)):(numberPerBand*i+remainderHere)
		remainder<-remainder-1
		surgeHere<-surgeSameOrder[sortedWhich]
		surgeHere<-sort(surgeHere)
		quantsHere<-surgeHere[aQuantiles]
		A1quants<-c(A1quants,quantsHere[1])
		A2quants<-c(A2quants,quantsHere[2])
		midPoints<-c(midPoints,(predOrdered[sortedWhich[length(sortedWhich)]]+predOrdered[sortedWhich[1]])/2)
	}
	midPoints<-c(midPoints,predOrdered[length(predOrdered)])

	a1EstVector<-ajFunc2(predCommon,A1quants,midPoints)
	a2EstVector<-ajFunc2(predCommon,A2quants,midPoints)
	return(list(a1=a1EstVector,a2=a2EstVector))
}

#BRA
ajFunc2<-function(x,aVec,midPoints) {
	LAT<-midPoints[1]
	HAT<-midPoints[length(midPoints)]
	m<-midPoints[2:(length(midPoints)-1)]
	numbOfTidalBands<-length(aVec)
	returnVec<-rep(0,length(x))
	returnVec[x>=LAT & x<m[1]]<-aVec[1]
	returnVec[x>=m[numbOfTidalBands] & x<=HAT]<-aVec[numbOfTidalBands]
	aTmp<-c()
	for (i in 2:numbOfTidalBands) {
		aTmp<-aVec[i]*(x-m[i-1])/(m[i]-m[i-1])+aVec[i-1]*(x-m[i])/(m[i-1]-m[i])
		returnVec[x>=m[i-1] & x<m[i]]<-aTmp[x>=m[i-1] & x<m[i]]
	}
	return(returnVec)
}

plotIntFunctions<-function(n,numbOfTidalBands) {
	place<- if (n==1) "oslo" else if (n==2) "heimsjo" else if (n==3) "honning" else if (n==4) "osloCorrected" else if (n==5) "narvik" else if (n==6) "harstad" else if (n==7) "tregde" else if (n==8) "andenesHours" else if (n==9) "vikerHours" else "synth"
	surgeValues<-get(paste(place,"Surge",sep="")) 
	predCommon<-get(paste(place,"PredCommon",sep="")) 

	#highQ<-sort(surgeValues)[0.9975*length(surgeValues)]
	aQuantLevels<-c(0.98,0.99)

	numberPerBand<-length(predCommon)/numbOfTidalBands
	remainder<-(numberPerBand-floor(numberPerBand))*numbOfTidalBands

	predOrderWhich<-order(predCommon)
	predOrdered<-predCommon[predOrderWhich]
	surgeSameOrder<-surgeValues[predOrderWhich]
	A1quants<-c()
	A2quants<-c()
	aQuantiles<-round(numberPerBand*aQuantLevels)
	midPoints<-predOrdered[1]
	bandBorders<-c()
	for (i in 1:numbOfTidalBands) {
		remainderHere<-if (remainder>0) 1 else 0
		sortedWhich<-(1+numberPerBand*(i-1)):(numberPerBand*i+remainderHere)
		remainder<-remainder-1
		surgeHere<-surgeSameOrder[sortedWhich]
		surgeHere<-sort(surgeHere)
		quantsHere<-surgeHere[aQuantiles]
		A1quants<-c(A1quants,quantsHere[1])
		A2quants<-c(A2quants,quantsHere[2])
		midPoints<-c(midPoints,(predOrdered[sortedWhich[length(sortedWhich)]]+predOrdered[sortedWhich[1]])/2)
		bandBorders<-c(bandBorders,predOrdered[sortedWhich[1]])
	}
	bandBorders<-c(bandBorders,max(predCommon))
	midPoints<-c(midPoints,predOrdered[length(predOrdered)])

	a1EstVector<-ajFunc2(predOrdered,A1quants,midPoints)
	a2EstVector<-ajFunc2(predOrdered,A2quants,midPoints)

	tmp<-rle(a1EstVector)
	a1SubSet<-tmp$values
	predSubSet<-c()
	thisRun<-1
	for (rl in tmp$lengths) {
		predSubSet<-c(predSubSet,predOrdered[thisRun])
		thisRun<-thisRun+rl
	}
	a1SubSet<-c(a1SubSet,a1SubSet[length(a1SubSet)])
	predSubSet<-c(predSubSet,max(predOrdered))

	tmp<-rle(a2EstVector)
	a2SubSet<-tmp$values
	predSubSet2<-c()
	thisRun<-1
	for (rl in tmp$lengths) {
		predSubSet2<-c(predSubSet2,predOrdered[thisRun])
		thisRun<-thisRun+rl
	}
	a2SubSet<-c(a2SubSet,a2SubSet[length(a2SubSet)])
	predSubSet2<-c(predSubSet2,max(predOrdered))

	par(mfrow=c(1,2))	
	plot(a1SubSet,predSubSet,type="l",xlim=c(0,100),xlab="Surge level (cm)",ylab="Tide level (cm)",main=expression(hat(a)[1](X)))
	for (border in bandBorders) {
		abline(h=border)
	}
	plot(a2SubSet,predSubSet2,type="l",xlim=c(0,100),xlab="Surge level (cm)",ylab="Tide level (cm)",main=expression(hat(a)[2](X)))
	for (border in bandBorders) {
		abline(h=border)
	}

	return(list(a1unique=c(min(unique(a1EstVector)),max(unique(a1EstVector))),a2unique=c(min(unique(a2EstVector)),max(unique(a2EstVector)))))
}

extremalIndexRatio<-function(n,r,quantileRange,plotOrNot=0) {
	place<- if (n==1) "oslo" else if (n==2) "heimsjo" else if (n==3) "honning" else if (n==4) "osloCorrected" else if (n==5) "narvik" else if (n==6) "harstad" else if (n==7) "tregde" else if (n==8) "andenesHours" else if (n==9) "vikerHours" else "synth"
	measuredValues<-get(paste(place,"MV",sep="")) 
	surgeValues<-get(paste(place,"Surge",sep=""))
	measuredRange<-sort(measuredValues)[quantileRange*length(measuredValues)]
	surgeRange<-sort(surgeValues)[quantileRange*length(surgeValues)]
	exiMV<-c()
	exiSurge<-c()
	for (i in 1:length(quantileRange)) {
		exiMV<-c(exiMV,exi(measuredValues,u=measuredRange[i],r=r))
		exiSurge<-c(exiSurge,exi(surgeValues,u=surgeRange[i],r=r))

	}
	if (plotOrNot==1) {
		yLim<-c(0,max(max(1/exiMV),max(1/exiSurge)))
		par(mfrow=c(3,1))
		plot(quantileRange,1/exiMV,type="l",ylim=yLim)
		plot(quantileRange,1/exiSurge,type="l",ylim=yLim)
		plot(quantileRange,exiMV/exiSurge,type="l",ylim=yLim)
	}
	return(list(eximeasured=exiMV,exisurge=exiSurge))
}

meanExceedance<-function(n,correctedOrNot=0,numbOfTidalBands=5,resolution=0.5) {
	place<- if (n==1) "oslo" else if (n==2) "heimsjo" else if (n==3) "honning" else if (n==4) "osloCorrected" else if (n==5) "narvik" else if (n==6) "harstad" else if (n==7) "tregde" else if (n==8) "andenesHours" else if (n==9) "vikerHours"
	values<-get(paste(place,"Surge",sep=""))
	
	if (correctedOrNot==1) {
		tmp<-conditionOnTide(n,numbOfTidalBands)
		values<-(values-tmp$a1)/(tmp$a2-tmp$a1)
	}
	ucheckvec<-seq(summary(surgeValues)[5],max(surgeValues),resolution)

	exceed<-0
	exceed.CIvec<-c()
	exceed.meanvec<-c()
	for (ucheck in ucheckvec) {
		exceed<-values[which(values>ucheck)]-ucheck
		exceed.CIvec<-c(exceed.CIvec,1.96*sd(exceed)/sqrt(length(exceed)))
		exceed.meanvec<-c(exceed.meanvec,mean(exceed))
	}
	exceed.upperCI<-exceed.meanvec+exceed.CIvec
	exceed.lowerCI<-exceed.meanvec-exceed.CIvec
	plot(ucheckvec,exceed.meanvec,type="l",xlab="Threshold u",ylab="Mean exceedance and CI",main="Mean exceedance rate with 95% confidence intervals",ylim=c(min(exceed.lowerCI[is.na(exceed.lowerCI)==FALSE]),max(exceed.upperCI[is.na(exceed.upperCI)==FALSE])))
	lines(ucheckvec,exceed.lowerCI,col="red")
	lines(ucheckvec,exceed.upperCI,col="red")
}

rjpmReturnDiffA<-function(n,bandsToTry) {
	rForBand<-c()
	rLower<-c()
	rUpper<-c()
	for (band in bandsToTry) {
		tmp<-rjpmReturn3(n,1,1,band,1)
		rForBand<-c(rForBand,tmp$retlevels[5])
		rLower<-c(rLower,tmp$lowerci[5])
		rUpper<-c(rUpper,tmp$upperci[5])
	}
	plot(bandsToTry,rForBand,type="l",xlab="Number of bands",ylab="200 year return level",ylim=c(min(rLower),max(rUpper)))
	lines(bandsToTry,rLower,col="red")
	lines(bandsToTry,rUpper,col="red")
}